<?php
/*******************************************************************************
simple gallery script (sgs)
copyright (c) 2002 osmo
version 0.5
20-aug-2002
*******************************************************************************/
include_once("sgs_classes.php");

/******************************************************************************
 main (here all the coordination happens)
  gal (contains the path to the gallery that has to be viewed)
  img (contains the image_name that has to be shown)
  pge (contains the page that has to be shown)
*******************************************************************************/
// variables for config
// start config here
$gal_by_default = "gallery/";
$thumb_per_page = 8;
$thumb_per_row = 4;
$sub_per_row = 3;
$link_per_page = 10;
$tmpl_by_default = "templates/orion/";
$tmpl_ext = ".tmpl";
// stop config here

// if no gallery path is given use default
if(!isset($gal)) {
 $gal = $gal_by_default;
}
// create gallery object
$gallery = new gallery($gal);

// if no template path is given use default
if(!isset($gallery->template)) {
 $gallery->template = $tmpl_by_default;
}

// check if mod is used
if(isset($gallery->mod)) {
 include_once($gallery->mod);
}

// generate the gallery
if(isset($gal) and isset($img)) {
 /******************************************************************************
  show image $img with path $gal
  info to be needed: next, current, previous image
 ******************************************************************************/
 if($img >= 0 and $img < $gallery->thumb_count) {
  // create template object
  $template = new template($gallery->template);

  if($img != 0) {
   // previous image exists
   $template->set_file("gal_prev_detail".$tmpl_ext);
   $template->set_params(array("gal" => $gal, "img" => $img - 1));
   $prev_tmpl = $template->get_output();
  }
  if($img != $gallery->thumb_count - 1) {
   // next image exists
   $template->set_file("gal_next_detail".$tmpl_ext);
   $template->set_params(array("gal" => $gal, "img" => $img + 1));
   $next_tmpl = $template->get_output();
  }
  // current image
  $template->set_file("gal_image_detail".$tmpl_ext);
  $template->set_params(array("img_path" => $gallery->get_image($img)));
  $img_tmpl = $template->get_output();
  // calculate the active page
  $gal_page_count = ceil($gallery->thumb_count / $thumb_per_page);
  for($i = 0; $i < $gal_page_count; $i++) {
   $gal_thumb_start = $i * $thumb_per_page;
   $gal_thumb_stop = $gal_thumb_start + $thumb_per_page;
   if($img >= $gal_thumb_start and $img < $gal_thumb_stop) {
    $pge = $i;
    $i = $gal_page_count;
   }
  }
  // use all templates in the main template
  // we also set all template paths correctly
  $template->set_file("gal_image".$tmpl_ext);
  $template->set_params(array("prev_tmpl" => $prev_tmpl,
  "next_tmpl" => $next_tmpl, "img_tmpl" => $img_tmpl,
  "gal" => $gallery->dir, "gal_name" => $gallery->name,
  "pge" => $pge, "pge_name" => $pge + 1, "path" => $gallery->template));
  print $template->get_output();
 }
 else {
  exit("Invalid image id");
 }
}
else {
 /******************************************************************************
  show gallery with path $gal
  info to be needed: all subgallery's (links to the gallery's)
                     all thumbnails (links to the full image)
 ******************************************************************************/
 // create template object
 $template = new template($gallery->template);

 // begin - subgallery
 if($gallery->sub_count != 0) {
  $gal_sub_count = 0;
  $sub_tmpl = "<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\" align=\"center\">\n<tr>\n";
  for($i = 0; $i < $gallery->sub_count; $i++) {
   $gal_sub_count++;
   $template->set_file("gal_sub_detail".$tmpl_ext);
   $gal_nfo = $gallery->get_nfo($gallery->dir.$gallery->sub[$i]);
   $template->set_params(array("gal" => $gallery->dir.$gallery->sub[$i],
   "gal_name" => $gal_nfo["name"], "gal_desc" => $gal_nfo["description"]));
   $sub_tmpl = $sub_tmpl."<td align=\"center\">\n".$template->get_output()."</td>\n";
   if($gal_sub_count == $sub_per_row) {
    $gal_sub_count = 0;
    $sub_tmpl = $sub_tmpl."</tr>\n<tr>\n";
   }
  }
  $sub_tmpl = $sub_tmpl."</tr>\n</table>";
 }
 // end - subgallery
 
 // begin thumbnail
 if($gallery->thumb_count != 0) {
  // set thumb to start with
  if($pge * $thumb_per_page > $gallery->thumb_count) {
   // if non-existing page is given
   $gal_thumb_start = 0;
   $pge = 0;
  }
  else {
   $gal_thumb_start = $pge * $thumb_per_page;
  }
  // set thumb to end with
  if($gal_thumb_start + $thumb_per_page > $gallery->thumb_count) {
   $gal_thumb_stop = $gallery->thumb_count;
  }
  else {
   $gal_thumb_stop = $gal_thumb_start + $thumb_per_page;
  }
  // start - thumbnail
  $gal_thumb_count = 0;
  $thumb_tmpl = "<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\" align=\"center\">\n<tr>\n";
  for($i = $gal_thumb_start; $i < $gal_thumb_stop; $i++) {
   $gal_thumb_count++;
   $template->set_file("gal_thumb_detail".$tmpl_ext);
   if(isset($gallery->hotlink)) {
    $template->set_params(array("gal" => $gal, "img" => $i,
    "img_path" => $gallery->dir.$gallery->thumb[$i],
    "img_name" => image::get_name($gallery->get_image($i)),
    "img_type" => image::get_ext($gallery->get_image($i)),
    "img_width" => "n/a", "img_height" => "n/a","img_size" => "n/a"));
   }
   else{
    $image = new image($gallery->get_image($i));
    $template->set_params(array("gal" => $gal, "img" => $i,
    "img_path" => $gallery->dir.$gallery->thumb[$i],
    "img_name" => $image->name, "img_width" => $image->width,
    "img_height" => $image->height, "img_size" => $image->size));
   }
   $thumb_tmpl = $thumb_tmpl."<td align=\"center\">\n".$template->get_output()."</td>\n";
   if($gal_thumb_count == $thumb_per_row) {
    $gal_thumb_count = 0;
    $thumb_tmpl = $thumb_tmpl."</tr>\n<tr>\n";
   }
  }
  $thumb_tmpl = $thumb_tmpl."</tr>\n</table>";
 }
 // end - thumbnail
 
 // begin - footer
 if($gallery->thumb_count != 0) {
  $gal_page_count = ceil($gallery->thumb_count / $thumb_per_page);
  // calculate the link limits
  for($i = 0; $i < $gal_page_count; $i++) {
   $gal_link_start = $i * $link_per_page;
   $gal_link_stop = $gal_link_start + $link_per_page;
   if($pge >= $gal_link_start and $pge < $gal_link_stop) {
    // check $gal_link_stop
    if($gal_link_stop > $gal_page_count) {
     $gal_link_stop = $gal_page_count;
    }
    $i = $gal_page_count;
   }
  }
  $pge_tmpl = "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\">\n<tr>\n<td align=\"center\">\n";
  $template->set_file("gal_page_detail".$tmpl_ext);
  if($gal_link_start != 0) {
   $template->set_params(array("gal" => $gal, "pge" => $gal_link_start - 1, "pge_name" => "<"));
   $pge_tmpl = $pge_tmpl.$template->get_output();
  }
  for($i = $gal_link_start; $i < $gal_link_stop; $i++) {
   $template->set_params(array("gal" => $gal, "pge" => $i, "pge_name" => $i + 1));
   $pge_tmpl = $pge_tmpl.$template->get_output();
  }
  if($gal_link_stop != $gal_page_count) {
   $template->set_params(array("gal" => $gal, "pge" => $gal_link_stop, "pge_name" => ">"));
   $pge_tmpl = $pge_tmpl.$template->get_output();
  }
  $pge_tmpl = $pge_tmpl."</td>\n</tr>\n</table>";
  $template->set_file("gal_thumb_footer".$tmpl_ext);
  $template->set_params(array("pge_tmpl" => $pge_tmpl));
  $footer_tmpl = $template->get_output();
 }
 // end - footer
 
 // begin - header
 // if previous gallery exists
 if($prev_gal = $gallery->get_prev()) {
  $template->set_file("gal_up_detail".$tmpl_ext);
  $template->set_params(array("prev_gal" => $prev_gal));
  $up_tmpl = $template->get_output();
 }
 $template->set_file("gal_thumb_header".$tmpl_ext);
 $template->set_params(array("up_tmpl" => $up_tmpl,
 "gal_name" => $gallery->name, "active_pge" => $pge + 1));
 $header_tmpl = $template->get_output();
 // end - header

 // use all templates in the main template
 // we also set all template paths correctly
 $template->set_file("gal_thumb".$tmpl_ext);
 $template->set_params(array("header_tmpl" => $header_tmpl,
 "thumb_tmpl" => $thumb_tmpl, "footer_tmpl" => $footer_tmpl,
 "sub_tmpl" => $sub_tmpl, "path" => $gallery->template));
 print $template->get_output();
}
?>
