<?php
/*******************************************************************************
image class
copyright (c) 2002 osmo
version 0.2
06-aug-2002
*******************************************************************************/
class image {
 var $file;
 var $width;
 var $height;
 var $type;
 var $size;
 var $name;
 
 /******************************************************************************
 image (constructor)
  arguments: $file (string)
 ******************************************************************************/
 function image($file) {
  if($nfo = $this->is_image($file)) {
   $this->file = $file;
   $this->width = $nfo[0];
   $this->height = $nfo[1];
   $this->type = $this->get_ext($file);
   $this->size = ceil(filesize($file)*1000/1024)/1000;
   $this->name = $this->get_name($file);
  }
  else {
   exit("The argument is not a valid filepath.");
  }
 }
 /******************************************************************************
 get_name
  arguments: $file (string)
 ******************************************************************************/
 function get_name($file) {
  return substr(basename($file), 0, strrpos(basename($file),"."));
 }
 /******************************************************************************
 get_ext
  arguments: $file (string)
 ******************************************************************************/
 function get_ext($file) {
  return substr(basename($file), strrpos(basename($file),".") + 1);
 }
 /******************************************************************************
 is_image
  arguments: $file (string)
 ******************************************************************************/
 function is_image($file) {
  return @getimagesize($file);
 }
 /******************************************************************************
 is_thumb
  arguments: $file (string)
 ******************************************************************************/
 function is_thumb($file) {
  if(image::is_image($file)) {
   return eregi("^_thb_", image::get_name($file));
  }
  else {
   return false;
  }
 }
}

/*******************************************************************************
gallery class
copyright (c) 2002 osmo
version 0.4
11-aug-2002
*******************************************************************************/

class gallery {
 var $dir;
 var $name;
 var $thumb = array();
 var $thumb_count;
 var $sub = array();
 var $sub_count;
 var $description;
 var $hotlink;
 var $template;
 var $mod;

 /******************************************************************************
 gallery (constructor)
  arguments: $dir (string)
 ******************************************************************************/
 function gallery($dir) {
  if($dh = @opendir($dir) and $nfo = gallery::get_nfo($dir)) {
   $this->dir = $dir;
   $this->name = $nfo["name"];
   $this->description = $nfo["description"];
   $this->hotlink = $nfo["hotlink"];
   $this->template = $nfo["template"];
   if(isset($nfo["mod"]) and file_exists($nfo["mod"]."gallery_mod.php")) {
    $this->mod = $nfo["mod"]."gallery_mod.php";
   }
   $this->thumb_count = 0;
   $this->sub_count = 0;
   while($file = @readdir($dh)) {
    if(image::is_thumb($dir.$file)) {
     array_push($this->thumb,$file);
     $this->thumb_count++;
    }
    elseif(gallery::is_gallery($dir.$file)) {
     array_push($this->sub,$file."/");
     $this->sub_count++;
    }
   }
   closedir($dh);
   natsort($this->thumb);
   natsort($this->sub);
  }
  else {
   exit("Could not create gallery object.");
  }
 }
 /******************************************************************************
 is_gallery
  arguments: $dir, $file (string)
 ******************************************************************************/
 function is_gallery($dir) {
  if(is_dir($dir) and !eregi("(\.|\.\.)$", $dir) and file_exists($dir."/gallery_nfo.php")) {
   return true;
  }
  else {
   return false;
  }
 }
 /******************************************************************************
 get_nfo
  arguments: $dir (string)
 ******************************************************************************/
 function get_nfo($dir) {
  if(@include_once($dir."gallery_nfo.php")) {
   return array("name" => $gallery_name, "description" => $gallery_description,
   "hotlink" => $gallery_hotlink, "template" => $gallery_template,
   "mod" => $gallery_mod);
  }
  else {
   return false;
  }
 }
 /******************************************************************************
 get_prev
  arguments: (nothing)
 ******************************************************************************/
 function get_prev() {
  $prev_dir = eregi_replace(basename($this->dir)."/$", "", $this->dir);
  if(file_exists($prev_dir."gallery_nfo.php")) {
   return $prev_dir;
  }
  else {
   return false;
  }
 }
 /******************************************************************************
 get_image
  arguments: $id (integer)
 ******************************************************************************/
 function get_image($id) {
  $image = eregi_replace("^_thb_", "", $this->thumb[$id]);
  if(isset($this->hotlink)) {
   return $this->hotlink.$image;
  }
  else {
   return $this->dir.$image;
  }
 }
}

/*******************************************************************************
template class
copyright (c) 2002 osmo
version 0.3
11-aug-2002
*******************************************************************************/
class template {
 var $dir;
 var $file;
 var $params;
 
 /******************************************************************************
 template (constructor)
  arguments: $dir (string)
 ******************************************************************************/
 function template($dir) {
  if(is_dir($dir)) {
   $this->dir = $dir;
  }
  else {
   exit("Could not create template object.");
  }
 }
 /******************************************************************************
 set_params
  arguments: $ass_arr (associative array)
 ******************************************************************************/
 function set_params($ass_arr) {
  if(is_array($ass_arr)) {
   $this->params = $ass_arr;
  }
  else {
   exit("The argument is not an associative array.");
  }
 }
 /******************************************************************************
 set_file
  arguments: $file (string)
 ******************************************************************************/
 function set_file($file) {
  if(file_exists($this->dir.$file)) {
   $this->file = $file;
  }
  else {
   exit("The argument is not a valid template.");
  }
 }
 /******************************************************************************
 get_output
  arguments: (nothing)
 ******************************************************************************/
 function get_output() {
  if(isset($this->file) and isset($this->params)) {
   $fp = fopen($this->dir.$this->file,r);
   $template = fread($fp, filesize($this->dir.$this->file));
   fclose($fp);
   while (list($key, $val) = each ($this->params)) {
    $template = str_replace("%".$key."%", $val, $template);
   }
   $to_eval = array();
   $start = 0;
   while($start = strpos($template, "%%", $start) and $stop = strpos($template, "%%", $start+=2)) {
    $str_eval = substr($template, $start, $stop-$start);
    array_push($to_eval, $str_eval);
    $start = $stop + 2;
   }
   while (list(, $val) = each ($to_eval)) {
    $template = str_replace("%%".$val."%%", @eval($val), $template);
   }
   return $template;
  }
  else {
   exit("The template parameters are not set correctly.");
  }
 }
}
?>
